module.exports = class Compiler {
  constructor(tree) {
    this.tree = tree
    this.result = ''
  }

  compile() {
    this.tree.forEach(node => {
      if (node.type === 'functionCall') {
        const attributes = node.args.map(arg => `${arg.attributeName}="${arg.attributeValue}"`)
        const compiler = new Compiler(node.subtree)
        const content = compiler.compile()
        this.result += `
          <${node.functionName}${attributes.length ? ' ' : ''}${attributes.join(' ')}>
            ${content}
          </${node.functionName}>
        `
      } else if (node.type === 'text') {
        this.result += node.content
      }
    })

    return this.result
  }
}
